package ir.apdroid.ipremote;

        import android.app.Activity;
        import android.content.Context;
        import android.content.SharedPreferences;
        import android.content.pm.ActivityInfo;
        import android.media.AudioManager;
        import android.media.MediaPlayer;
        import android.net.DhcpInfo;
        import android.net.wifi.WifiInfo;
        import android.net.wifi.WifiManager;
        import android.os.AsyncTask;
        import android.os.Bundle;
        import android.os.Handler;
        import android.os.Message;
        import android.support.v7.app.AppCompatActivity;
        import android.text.Editable;
        import android.text.TextWatcher;
        import android.text.format.Formatter;
        import android.util.Log;
        import android.view.View;
        import android.widget.Button;
        import android.widget.EditText;
        import android.widget.ImageView;
        import android.widget.LinearLayout;
        import android.widget.TextView;
        import android.widget.Toast;
        import android.widget.ToggleButton;

        import java.io.IOException;
        import java.math.BigInteger;
        import java.net.InetAddress;
        import java.net.Socket;
        import java.net.UnknownHostException;
        import java.nio.ByteOrder;

public class MainActivity extends AppCompatActivity {

    SharedPreferences appPrefs;
    SharedPreferences.Editor prefsEditor;

    TextView IP_tv,info;
    static TextView status_tv;
    boolean connected = false;
    Button btn_connect;
    EditText textBox_IP;

    String Module_IP;

    static final String NICKNAME = "Start";
    //---socket---
    InetAddress serverAddress;
    Socket socket;


    //---thread for communicating on the socket---
    CommsThread commsThread;

    //---used for updating the UI on the main activity---
    static Handler UIupdater = new Handler() {
        @Override
        public void handleMessage(Message msg) {
            int numOfBytesReceived = msg.arg1;
            byte[] buffer = (byte[]) msg.obj;

            //---convert the entire byte array to string---
            String strReceived = new String(buffer);

            //---extract only the actual string received---
            strReceived = strReceived.substring(
                    0, numOfBytesReceived);

            status_tv.setText(strReceived);

            /*
            if ( strReceived.contains("RELAY TURN ON") ){
                lamp.setImageResource(R.drawable.l_on);
            }

            if ( strReceived.contains("RELAY TURN OFF") ){
                lamp.setImageResource(R.drawable.l_off);
            }
            */
            //---display the text received on the TextView---
            //txtMessagesReceived.setText(
            //        txtMessagesReceived.getText().toString() +
            //                strReceived);
        }
    };



    private class CreateCommThreadTask extends AsyncTask<Void, Integer, Void> {
        @Override
        protected Void doInBackground(Void... params) {
            try {
                //---create a socket---
                serverAddress =
                        InetAddress.getByName(Module_IP);
                socket = new Socket(serverAddress, 1716);
                commsThread = new CommsThread(socket);
                commsThread.start();
                //---sign in for the user; sends the nick name---
                sendToServer(NICKNAME);
                connected = true;

            } catch (UnknownHostException e) {
                Log.d("Sockets", e.getLocalizedMessage());
            } catch (IOException e) {
                Log.d("Sockets", e.getLocalizedMessage());
            }
            return null;
        }
        @Override
        protected void onPostExecute(Void arg0) {

            if(connected){
                cnctd();
            }else{
                Toast.makeText(getApplicationContext(),"متصل نشد",Toast.LENGTH_SHORT).show();
            }
        }

    }

    public void cnctd(){
        IP_tv.setText(Module_IP+":1716");
        textBox_IP.setEnabled(false);
        btn_connect.setEnabled(false);
        btn_connect.setText("متصل شد");
    }

    private class WriteToServerTask extends AsyncTask
            <byte[], Void, Void> {
        protected Void doInBackground(byte[]...data) {
            commsThread.write(data[0]);
            return null;
        }
    }

    private class CloseSocketTask extends AsyncTask
            <Void, Void, Void> {
        //@Override
        protected Void doInBackground(Void... params) {
            try {
                if(connected){
                    socket.close();
                }

            } catch (Exception e) {
                //Log.d("Sockets", e.getLocalizedMessage());
                Toast.makeText(getBaseContext(),"ErrInside",Toast.LENGTH_SHORT).show();
            }
            return null;
        }
    }



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);
        setContentView(R.layout.activity_main);

        init();
        main();
    }

    public void init(){
        IP_tv = (TextView)findViewById(R.id.IP_tv);
        status_tv = (TextView)findViewById(R.id.status_tv);
        info = (TextView)findViewById(R.id.info);
        btn_connect = (Button)findViewById(R.id.button);
        textBox_IP = (EditText)findViewById(R.id.editText);

        appPrefs = getSharedPreferences("ir.apdroid.ipremote_preferences",MODE_PRIVATE);
        prefsEditor = appPrefs.edit();

        // default [only one time executed]
        if ("".equalsIgnoreCase(appPrefs.getString("remote_IP", ""))){// if first run (no shared pref save) set default values
            prefsEditor.putString("remote_IP", "192.168.1.101");
            prefsEditor.commit();
        }

        // loading
        textBox_IP.setText( appPrefs.getString("remote_IP", "") );

    }

    public void main(){

        if(textBox_IP.getText().toString().equalsIgnoreCase("")){
            btn_connect.setEnabled(false);
        }

        textBox_IP.addTextChangedListener(new TextWatcher() {

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                if(textBox_IP.getText().toString().length()==0){
                    btn_connect.setEnabled(false);
                }
                else{
                    btn_connect.setEnabled(true);
                }
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            @Override
            public void afterTextChanged(Editable s) {
            }
        });



        //info.setText(wifiIpAddress(this) );
        //info.setText("Buy Pro App (without this ads) from AVR64.com ");

        //final WifiManager manager = (WifiManager) super.getSystemService(WIFI_SERVICE);
        //final DhcpInfo dhcp = manager.getDhcpInfo();
        //final String address = Formatter.formatIpAddress(dhcp.gateway);


    }


    public void on_click(View view) {
        if(connected) {
            sendToServer("on");
            Toast.makeText(this,"در حال روشن کردن",Toast.LENGTH_SHORT).show();
        }else{
            Toast.makeText(this,"اتصال برقرار نیست",Toast.LENGTH_SHORT).show();
        }


    }

    public void off_click(View view) {
        if(connected) {
            sendToServer("off");
            Toast.makeText(this,"در حال خاموش کردن",Toast.LENGTH_SHORT).show();
        }else{
            Toast.makeText(this,"اتصال برقرار نیست",Toast.LENGTH_SHORT).show();
        }

    }

    private void sendToServer(String message) {
        byte[] theByteArray = message.getBytes();
        new WriteToServerTask().execute(theByteArray);
    }



    @Override
    public void onPause() {
        super.onPause();

        try{
            new CloseSocketTask().execute();
            //if(connected){
            //socket.close();
            //}

        }catch(Exception e){
            Log.d("Sockets","onPauseError:"+e);
        }

    }


    public void btn_connect(View v){
        final String address = textBox_IP.getText().toString();

        prefsEditor.putString("remote_IP", address);
        prefsEditor.commit();


        Module_IP = address;

        try{
            new CreateCommThreadTask().execute();
        }catch(Exception e){
            Log.d("Sockets","onResomeError");
        }

    }


}
